// CmdDloader.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <iostream>

#include "CmdDloader.h"
#include "PipeClient.h"
#include "CfgInfoOpr.h"
#include "DloaderProxy.h"
#include "FindValidDut.h"

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

HANDLE  g_hThread = NULL;
DWORD   g_dwThreadID = 0; 
DWORD	g_dwRetCode	 = DOWNLOAD_OK;
CDloaderProxy   g_cDloaderProxy;
CCfgInfoOpr     g_cCfgOpr;
DWORD WINAPI WaitExit(LPVOID pParam);
// The one and only application object

//exit dos kill 
BOOL WINAPI CmdConsoleHandler(DWORD CEvent)
{
    switch (CEvent)
    {
    case CTRL_C_EVENT:// handle the ctrl-c signal.
        printf("ctrl-c event - ExitDloader\n\n");
        g_cDloaderProxy.ExitDloader();
        break;

    case CTRL_CLOSE_EVENT:// ctrl-close: confirm that the user wants to exit.
        printf("ctrl-close event\n\n");
        g_cDloaderProxy.KillDloader();
        break;
    case CTRL_BREAK_EVENT:// pass other signals to the next handler.
        printf("ctrl-break event\n\n");
        break;
    case CTRL_LOGOFF_EVENT:
        printf("ctrl-logoff event\n\n");
        break;
    case CTRL_SHUTDOWN_EVENT:
        printf("ctrl-shutdown event\n\n");
        break;
    default:
        return false;
    }
    return(true);
}


CWinApp theApp;

using namespace std;
void ShowUsage()
{
    _tprintf(_T("CmdDloader Usage\n"));
    _tprintf(_T("CmdDloader.exe <-pac file> [-port portnumber] [-ReadNV nvfile]\n"));
    _tprintf(_T("e.g.CmdDloader.exe -pac d:\\test.pac -port 5\n"));
}
DWORD WINAPI WaitExit(LPVOID pParam)
{
    CDloaderProxy* pDloaderProxy = (CDloaderProxy*)pParam;
    if ( NULL == pParam )
    {
        return 1;
    }
    char szBuf[MAX_PATH] = {0};
    while(TRUE)
    {
        std::cin.getline( szBuf, MAX_PATH );
        if (
            stricmp( szBuf, "q" ) == 0     ||
            stricmp( szBuf, "quit" ) == 0  ||
            stricmp( szBuf, "exit" ) == 0 
            )

        {
            pDloaderProxy->ExitDloader();
            _tprintf(_T("User Exit DLoader.\n"));
            break;
        }
        else if( ( GetKeyState( VK_LCONTROL ) & 0x8000 ) && ( GetKeyState( 'C' ) & 0x8000 ) ) 
        {
            printf( "Exit CMD.\n" );
        }
    }
    return 0;
}


void WINAPI RecvDataCB(LPBYTE lpRecvData,DWORD dwDataLen)
{
    if(lpRecvData && dwDataLen >0 )
    {
        CString strInfo(lpRecvData);
		if ( -1 != strInfo.Find(_T("[ERROR]")) )
		{
			g_dwRetCode = DOWNLOAD_ERRDOWNLOAD;
		}
		if (g_cCfgOpr.m_bEZMode)
		{
			printf("%s \n",lpRecvData); 
			fflush(stdout);
			return;
		}
        if (g_cCfgOpr.m_bShowProcess)
        {
            if ( -1 != strInfo.Find(_T("%")) )
            {
                if (dwDataLen == 4)
                {
                    printf("\b\b\b\b\b\b(%s)",lpRecvData);
                } 
            }
            else
            {
                printf("\n%-56s ",lpRecvData);            
            }
        }
        else
        {
            if (-1 == strInfo.Find(_T("%")))
            {
                printf("\n%-56s ",lpRecvData); 
            }
            
        }
		fflush(stdout);
        
		if (-1 != strInfo.Find(_T("[ExitApp]")))
		{
			exit(0);
		}

        if (-1 != strInfo.Find(_T("Passed")) || -1 != strInfo.Find(_T("[ERROR]")))
        {
            g_cDloaderProxy.ExitDloader();
        }
		
    }
}

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
    int nRetCode = DOWNLOAD_ERRPARAM;
    DWORD dwProcID = GetCurrentProcessId();
    // initialize MFC and print and error on failure
    if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
    {
        // TODO: change error code to suit your needs
        _tprintf(_T("Fatal Error: MFC initialization failed\n"));
        return nRetCode;
    }

    //	hQuitCmdEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL);
    if (SetConsoleCtrlHandler((PHANDLER_ROUTINE)CmdConsoleHandler, TRUE) == FALSE)
    {
        //		CloseHandle(hQuitCmdEvent);
        return -1;
    }

	// TODO: code your application's behavior here.
	BOOL	bReadFixNV = FALSE;
    DWORD   dwComPort   = 0;
	DWORD   dwMultCount = 1;
    CString strPacFile;
	CString strSaveFixNV;
    CString strTimeOut;
    BOOL    bKClearDloader = FALSE;
    BOOL    bWriteSN = FALSE;
	BOOL    bWriteSN2 = FALSE;
    BOOL    bDetectTimeOut = FALSE;
	CString strSN2;
	strSN2.Empty();
    CString strSN;
    strSN.Empty();
    strPacFile.Empty();
    strTimeOut.Empty();

    DWORD dwBaudRate = 115200;
    for(int i= 1; i<  argc; ++i)
    {
        if( 0 == _tcsicmp(argv[i],_T("-pac")) )   
        {
            if((i+1)<argc)
            {
                strPacFile = argv[++i];
            }
        }
		else if( 0 == _tcsicmp(argv[i],_T("-port")) )   
		{
			if((i+1)<argc)
			{
				dwComPort = _ttoi(argv[++i]);
			}
		}
        else if( 0 == _tcsicmp(argv[i],_T("-baudrate")) )
        {
            if((i+1)<argc)
            {
                dwBaudRate = _ttoi(argv[++i]);
            }
        }
		else if( 0 == _tcsicmp(argv[i],_T("-count")) )   
		{
			if((i+1)<argc)
			{
				dwMultCount = _ttoi(argv[++i]);
			}
		}
		else if (0 == _tcsicmp(argv[i],_T("-ReadNV")))
		{
			if((i+1)<argc)
			{
				bReadFixNV = TRUE;
				strSaveFixNV = argv[++i];
				::DeleteFile(strSaveFixNV.operator LPCTSTR());
            }
        }
        else if( 0 == _tcsicmp(argv[i],_T("-c")) )   
        {
            bKClearDloader = TRUE;
        }

        else if (0 == _tcsicmp(argv[i], _T("-WriteSN")))
        {
            bWriteSN = TRUE;
            strSN = argv[++i];
            _tprintf(_T("WriteSN arguments[%s]\n"), strSN);
        }
		else if (0 == _tcsicmp(argv[i], _T("-WriteSN2")))
		{
			bWriteSN2 = TRUE;
			strSN2 = argv[++i];
            _tprintf(_T("WriteSN2 arguments[%s]\n"), strSN2);
		}
        else if (0 == _tcsicmp(argv[i], _T("-timeout")))
        {
            bDetectTimeOut = TRUE;
            strTimeOut = argv[++i];
        }
    }
    if ( strPacFile.IsEmpty())
    {
        _tprintf(_T("Invalid arguments\n"));

        ShowUsage();
        return DOWNLOAD_ERRPARAM;
    }
    if (!strPacFile.IsEmpty())
    {
        CFileFind finder;

        if (!finder.FindFile(strPacFile.operator LPCTSTR()))
        {
            _tprintf(_T("Invalid arguments,Pac file [%s] don't exist.\n"), strPacFile.operator LPCTSTR());
            ShowUsage();
            return nRetCode;
        }
        finder.Close();
    }

    if (!strTimeOut.IsEmpty()) {
        TCHAR szCfgFile[MAX_PATH] = { 0 };
        _stprintf(szCfgFile, _T("%s\\CmdDloader.ini"), GetModuleFilePath(FALSE));
        CString strCmdTimeOut;
        strCmdTimeOut.Format(_T("%s000"), strTimeOut.operator LPCWSTR());
        ::WritePrivateProfileString(_T("Setting"), _T("WaitDUTTimeout"), strCmdTimeOut.operator LPCTSTR(), szCfgFile);
    }
    CFindValidDut   cDutMoniter;

	if ( 0 == dwComPort) // need detect device
	{
		if (!g_cCfgOpr.m_bEZMode)
		{
			printf("Detecting download device ... \n");
			fflush(stdout);
		}

		dwComPort = cDutMoniter.FindOneValidDut();
	}

	if ( 0 == dwComPort)
	{
		_tprintf(_T("[ERROR] fail:Not find valid download devices.\n"));
		return DOWNLOAD_ERR_DETECT_DUT;
	}
	if (g_cCfgOpr.m_bEZMode)
	{
		//_tprintf(_T("[Status] Begin\n"));
	}
	else
	{
		_tprintf(_T("||*****************************************************************||\n"));
		_tprintf(_T("  Pac  : %s \n"),strPacFile.operator LPCTSTR());
		if(DO_PACKET_PORT != dwComPort)
		{
			_tprintf(_T("  Port : %d \n"),dwComPort);
		}
		_tprintf(_T("||*****************************************************************||\n"));

	}
    
    fflush(stdout);
    CPipeClient cPipeClient;

    ///Hide cursor
    CONSOLE_CURSOR_INFO cci;
    GetConsoleCursorInfo(GetStdHandle(STD_OUTPUT_HANDLE),&cci);
    cci.bVisible = FALSE;
    SetConsoleCursorInfo(GetStdHandle(STD_OUTPUT_HANDLE), &cci);
    
    if ( !g_cCfgOpr.m_strFlashAppName.IsEmpty())
    {
        CString strBaudrate,strFlashAppCfgFile;
        strBaudrate.Format(_T("%d"),dwBaudRate);
		strFlashAppCfgFile.Format(_T("%s\\%s.ini"),GetModuleFilePath(FALSE),GetStrFileTitle(g_cCfgOpr.m_strFlashAppName));
        ::WritePrivateProfileString( _T("Serial port"),_T("Baud rate"),strBaudrate.operator LPCTSTR(),strFlashAppCfgFile.operator LPCTSTR());
		
        CString strDloaderApp;
        strDloaderApp.Format(_T("%s\\%s"),GetModuleFilePath(FALSE),g_cCfgOpr.m_strFlashAppName);
        g_cDloaderProxy.SetFlashApp(strDloaderApp);
    }

    if (bWriteSN) {
        CString  strFlashAppCfgFile;
        strFlashAppCfgFile.Format(_T("%s\\%s.ini"), GetModuleFilePath(FALSE), GetStrFileTitle(g_cCfgOpr.m_strFlashAppName));
        //_tprintf(_T("  strFlashAppCfgFile : %s \n"), strFlashAppCfgFile.operator LPCWSTR());
        if (strSN.IsEmpty())
        {
            printf("SN is empty,Please input SN ... \n");
        }
        else
        {
            ::WritePrivateProfileString(_T("SN"), _T("NeedPhaseCheck"), _T("1"), strFlashAppCfgFile.operator LPCTSTR());
            ::WritePrivateProfileString(_T("SN"), _T("FixedSN"), strSN.operator LPCWSTR(), strFlashAppCfgFile.operator LPCTSTR());
            ::WritePrivateProfileString(_T("SN"), _T("AutoStartAfterInputSN"), _T("1"), strFlashAppCfgFile.operator LPCTSTR());
            ::WritePrivateProfileString(_T("SN"), _T("AutoGenerateSN"), _T("1"), strFlashAppCfgFile.operator LPCTSTR());
        }
    }
    else
    {
        CString  strFlashAppCfgFile;
        strFlashAppCfgFile.Format(_T("%s\\%s.ini"), GetModuleFilePath(FALSE), GetStrFileTitle(g_cCfgOpr.m_strFlashAppName));
        ::WritePrivateProfileString(_T("SN"), _T("NeedPhaseCheck"), _T("0"), strFlashAppCfgFile.operator LPCTSTR());
    }

	if (bWriteSN2) 
	{
        CString  strFlashAppCfgFile;
        strFlashAppCfgFile.Format(_T("%s\\%s.ini"), GetModuleFilePath(FALSE), GetStrFileTitle(g_cCfgOpr.m_strFlashAppName));
		if (strSN2.IsEmpty())
		{
			printf("SN is empty,Please input SN ... \n");
		}
		else
		{
			::WritePrivateProfileString(_T("SN"), _T("NeedPhaseCheck"), _T("1"), strFlashAppCfgFile.operator LPCTSTR());
			::WritePrivateProfileString(_T("SN"), _T("FixedSN2"), strSN2.operator LPCWSTR(), strFlashAppCfgFile.operator LPCTSTR());
			::WritePrivateProfileString(_T("SN"), _T("WriteSN2Enable"), _T("1"), strFlashAppCfgFile.operator LPCTSTR());
			::WritePrivateProfileString(_T("SN"), _T("AutoGenerateSN"), _T("1"), strFlashAppCfgFile.operator LPCTSTR());
			::WritePrivateProfileString(_T("SN"), _T("AutoStartAfterInputSN"), _T("1"), strFlashAppCfgFile.operator LPCTSTR());
		}
	}
	else 
	{
        CString  strFlashAppCfgFile;
        strFlashAppCfgFile.Format(_T("%s\\%s.ini"), GetModuleFilePath(FALSE), GetStrFileTitle(g_cCfgOpr.m_strFlashAppName));
		::WritePrivateProfileString(_T("SN"), _T("WriteSN2Enable"), _T("0"), strFlashAppCfgFile.operator LPCTSTR());
	}


    if (bKClearDloader)
    {
        g_cDloaderProxy.KillDloader();
    }

    cPipeClient.SetPipeServerName(g_cCfgOpr.m_strPipeServer);
    cPipeClient.SetPipeName(g_cCfgOpr.m_strPipeName);
    cPipeClient.SetRecvCallback(RecvDataCB);
    cPipeClient.Init(dwComPort);
    g_cDloaderProxy.SetFlashArgv(strPacFile, dwComPort, strSN, strSN2,strTimeOut,dwMultCount, g_cCfgOpr.m_bEZMode);
	g_cDloaderProxy.EnableReadFixnv(bReadFixNV,strSaveFixNV);
	g_dwRetCode = g_cDloaderProxy.StartDloader() ? DOWNLOAD_OK : DOWNLOAD_ERRLSTARTDLOADER;
  //  g_hThread = CreateThread(NULL,0,WaitExit,(LPVOID)(&g_cDloaderProxy),0,&g_dwThreadID); 

    while ( !g_cDloaderProxy.IsEnd() )
    {
        Sleep(1000);      
    }



    cPipeClient.UnInit();
    ///Show cursor
    GetConsoleCursorInfo(GetStdHandle(STD_OUTPUT_HANDLE),&cci);
    cci.bVisible = TRUE;
    SetConsoleCursorInfo(GetStdHandle(STD_OUTPUT_HANDLE), &cci);

    //g_cDloaderProxy.ExitDloader();
  /*  if (g_hThread)
    {

        if( WAIT_OBJECT_0 != WaitForSingleObject(g_hThread,1000) )
        {
            TerminateThread(g_hThread,1);
            //ProcessMgr cProcMgr;
            //cProcMgr.KillXProcess_ByPid(dwProcID);
            _exit(5);

        }
        CloseHandle(g_hThread);
        g_hThread = NULL;
    }*/
	return g_dwRetCode;
}
