#pragma once
#include "ISpLogExport.h"
    
//////////////////////////////////////////////////////////////////////////
/// 
class CTr
{
    CLASS_UNCOPYABLE(CTr);
public:
    CTr(void);
    virtual ~CTr(void);

    /// 
    /// Get ISpLog object
    ///
    ISpLog* GetISpLogObject(void)const { return m_lpTr; };

    /// Binding ISpLog Object
    void    BindLog(ISpLog* lpOuter, LPCSTR lpszModule);

    ///
    /// Initialize & Free
    ///
    BOOL    trInit(
        ISpLog* lpOuter, 
        LPCSTR  lpszModule = NULL, 
        UINT32  nLv = SPLOGLV_ERROR, 
        BOOL    bRollback = TRUE,
        UINT32  nOpenFlag = splog::defaultFlags,
		LPCSTR  lpszFile = NULL);

    void    trFree(BOOL bWait = TRUE/*Wait all logs flush first and then free*/);
    
    BOOL    Open(void);
    void    Close(BOOL bWait = TRUE);
    
    ///
    /// Tr Interface: LogRawStrA/LogRawStrW
    /// 
    BOOL    LogRawStrA(UINT32 nLv, LPCSTR  lpszString);
    BOOL    LogRawStrW(UINT32 nLv, LPCWSTR lpszString);

    ///
    /// Tr Interface: LogFmtStrA/LogFmtStrW
    /// 
    BOOL    LogFmtStrA(UINT32 nLv, LPCSTR  lpszFmt, ...);
    BOOL    LogFmtStrW(UINT32 nLv, LPCWSTR lpszFmt, ...);

    ///
    /// Tr Interface: LogBufData
    /// 
    BOOL    LogBufData(UINT32 nLv, const void* lpData, UINT32 nDataSize, UINT32 nFlag = LOG_WRITE, const UINT32* lpnExpSize = NULL);

private:
    ISpLog*    m_lpTr;
    BOOL       m_bInnerISpLog;
    CHAR       m_szModule[MAX_MODULE_NAME_LEN];
    OpenArgs_T m_Args;
};


